﻿using UnityEngine;
using System.Collections;
using Assets.Scripts;
using Assets.Scripts.Game;

public class Ladder : PhysicsScriptBase {

	public int LowerLevelIndex = 0;
	public Transform HelpPopup;

	Game game;
	
	void Start() {

	}
	
	// Update is called once per frame
	void Update () {
		var gm = GameObject.FindGameObjectWithTag("GameManager");
		if (gameObject == null)
			Debug.Log("Could not find GameManagerObject object byt tagName GameManager");
		GameManager gameManager = null;
		if (gm != null)
			gameManager = gm.GetComponent("GameManager") as GameManager;
		if (gameManager == null)
			Debug.Log("Could not find GameManager Script");
		game = gameManager.Game;
	}
	
	void OnTriggerEnter2D(Collider2D other)
	{
		if (other.gameObject.tag == "Player")
		{
			var _helpPopupSR = HelpPopup.gameObject.GetComponent<SpriteRenderer>();
			_helpPopupSR.enabled = true;
			game.setAboveLadder(LowerLevelIndex);
		}
	}
	
	void OnTriggerStay2D(Collider2D other)
	{
		Debug.Log("Ladder " + LowerLevelIndex + " -> " + (LowerLevelIndex + 1) + " (cur=" + game.Layer + ", other=" + other.gameObject.tag + ")");
		if (other.gameObject.tag == "Player")
		{
			Debug.Log("OK");
			if ( LowerLevelIndex == 3 ) {
				game.ChangeLayer(10, false);
			}
			if (Input.GetKey(KeyCode.Z)) { // up
				Debug.Log("UP");
				if ( game.Layer == LowerLevelIndex ) {
					game.ChangeLayer(1, true);
				}
			}
			if (Input.GetKey(KeyCode.C)) { // down
				Debug.Log("DOWN");
				if ( game.Layer == LowerLevelIndex + 1 ) {
					game.ChangeLayer(-1, true);
				}
			}
		}
	}

	void OnTriggerExit2D(Collider2D other)
	{
		if (other.gameObject.tag == "Player")
		{
			var _helpPopupSR = HelpPopup.gameObject.GetComponent<SpriteRenderer>();
			_helpPopupSR.enabled = false;
			game.unsetAboveLadder();
		}
	}
}
