﻿Shader "Custom/PostProcVignette" {
Properties {
 _MainTex ("", 2D) = "white" {}
 _VignetteRad ("VignetteRad",  Range (1.0,2.0)) = 1.0
}
 
SubShader {
 
ZTest Always Cull Off ZWrite Off Fog { Mode Off } //Rendering settings
 
 Pass{
  CGPROGRAM
  #pragma vertex vert
  #pragma fragment frag
  #include "UnityCG.cginc" 
  //we include "UnityCG.cginc" to use the appdata_img struct
    
  struct v2f {
   float4 pos : POSITION;
   half2 uv : TEXCOORD0;
  };
   
  //Our Vertex Shader 
  v2f vert (appdata_img v){
   v2f o;
   o.pos = mul (UNITY_MATRIX_MVP, v.vertex);
   o.uv = MultiplyUV (UNITY_MATRIX_TEXTURE0, v.texcoord.xy);
   return o; 
  }
    
  sampler2D _MainTex; //Reference in Pass is necessary to let us use this variable in shaders
  float _VignetteRad; 
    
  //Our Fragment Shader
  fixed4 frag (v2f i) : COLOR{
   fixed4 orgCol = tex2D(_MainTex, i.uv); //Get the orginal rendered color 
     
   //Make changes on the color
   fixed4 col = fixed4(orgCol.r, orgCol.g, orgCol.b, 1);
   

    float2 wcoord = i.uv;///_ScreenParams.xy;
	float vig = clamp(_VignetteRad * length(wcoord-0.5),0.0,1.0);
	return lerp (col * 1.2,col * 0.3,vig * 1.2);// * col;
     
   //return col;
  }
  ENDCG
 }
} 
 FallBack "Diffuse"
}