﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(BoxCollider2D))]
[RequireComponent(typeof(SpriteRenderer))]
public class TitleScreenExit : MonoBehaviour {

    Sprite up;
    Sprite down;
    Sprite over;

    // Use this for initialization
    void Start()
    {
        up = Resources.Load("Sprites/TitleScreen/exit_button_up", typeof(Sprite)) as Sprite;
        down = Resources.Load("Sprites/TitleScreen/exit_button_down", typeof(Sprite)) as Sprite;
        over = Resources.Load("Sprites/TitleScreen/exit_button_over", typeof(Sprite)) as Sprite;
    }



    double timePressed = 0.0;
    bool wasPressed = false;

    // Update is called once per frame
    void Update()
    {
        if (wasPressed)
        {
            timePressed += Time.deltaTime;
            if (timePressed > 0.8)
            {
                (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = up;
                wasPressed = false;
                timePressed = 0.0;
            }
        }
    }

    void OnMouseEnter()
    {
        (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = over;
    }

    void OnMouseExit()
    {
        (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = up;
    }

    void OnMouseDown()
    {
        if (Input.GetMouseButtonDown(0))
        {
            Debug.Log("We are hitting the start game button");
            (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = down;
            wasPressed = true;
        }
    }

    void OnMouseUp()
    {
        if (Input.GetMouseButtonUp(0))
        {
            //TODO: Start game
        }
    }
}
