﻿using UnityEngine;
using System.Collections;
using Assets.Scripts.Game;

public class FilterWall : MonoBehaviour {

	public int Color = 0;
	
	GameManager gameManager;
	GameObject physobj = null;

	// Use this for initialization
	void Start () {
		var gm = GameObject.FindGameObjectWithTag("GameManager");
		if (gameObject == null)
			Debug.Log("Could not find GameManagerObject object byt tagName GameManager");
		if (gm != null)
			gameManager = gm.GetComponent("GameManager") as GameManager;
		if (gameManager == null)
			Debug.Log("Could not find GameManager Script");
		gameManager.Game.Player.PlayerGotAbility += Player_PlayerGotAbility;
	}
	
	void Player_PlayerGotAbility(object sender, System.EventArgs e)
	{
		//EnableCollision();
		Player player = sender as Player;
		foreach ( Ability ability in player.Abilities ) {
			if ( ability is ColorAbility ) {
				ColorAbility ca = ability as ColorAbility;
				if ( ca.Color == Color ) {
					DisableCollision();
					break;
				}
			}
		}
	}

	void EnableCollision() {
		if ( physobj == null ) {
			physobj = GameObject.Find(name + "_phys");
			if ( physobj == null ) {
				return;
			}
		}
		Collider2D coll = physobj.GetComponent<Collider2D>();
		coll.enabled = true;
		SpriteRenderer sprdr = gameObject.GetComponent<SpriteRenderer>();
		Color col = sprdr.color;
		col.a = 1.0f;
		sprdr.color = col;

	}

	void DisableCollision() {
		if ( physobj == null ) {
			physobj = GameObject.Find(name + "_phys");
			if ( physobj == null ) {
				return;
			}
		}
		Collider2D coll = physobj.GetComponent<Collider2D>();
		coll.enabled = false;
		SpriteRenderer sprdr = gameObject.GetComponent<SpriteRenderer>();
		Color col = sprdr.color;
		col.a = 0.3f;
		sprdr.color = col;
	}
}
