﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets.Scripts.Game
{
    public class Player
    {
        List<Item> _inventory = new List<Item>();
        public List<Item> Inventory { get { return _inventory; } }

        List<Ability> _abilities = new List<Ability>();
        public List<Ability> Abilities { get { return _abilities; } }

        Ability _selectedAbility;
        public Ability SelectedAbility { get { return _selectedAbility; } set { _selectedAbility = value; } }

        public event EventHandler PlayerPickedUpItem;
        public event EventHandler PlayerGotAbility;

        public Player()
        {
            
        }

        public void PickupItem(Items.Gloves gloves)
        {
            if (!Inventory.Contains(gloves))
            {
                Inventory.Add(gloves);
                if (PlayerPickedUpItem != null)
                    PlayerPickedUpItem(gloves, new EventArgs());
            } 
        }

		public void GainAbility(Ability ability) {
			_abilities.Add(ability);
			SelectedAbility = ability;
			if ( ability is ColorAbility ) {
				ColorAbility ca = ability as ColorAbility;
				GameManager gm = GameObject.FindGameObjectWithTag("GameManager").GetComponent("GameManager") as GameManager;
				if (gm == null) Debug.Log("Could not find game!! ");
				Color col = Color.white;
				if ( ca.Color == 0 ) {
					col = gm.color0;
				}
				else if ( ca.Color == 1 ) {
					col = gm.color1;
				}
				else if ( ca.Color == 2 ) {
					col = gm.color2;
				}
				else if ( ca.Color == 3 ) {
					col = gm.color3;
				}
				else if ( ca.Color == 4 ) {
					col = gm.color4;
				}
				SpriteRenderer smngr = GameObject.FindGameObjectWithTag("Player").GetComponent<SpriteRenderer>() as SpriteRenderer;
				smngr.color = Color.Lerp(Color.white, col, 0.7f);
			}
			else {
				SpriteRenderer smngr = GameObject.FindGameObjectWithTag("Player").GetComponent<SpriteRenderer>() as SpriteRenderer;
				smngr.color = Color.white;
			}
			if (PlayerGotAbility != null)
				PlayerGotAbility(this, new EventArgs());
		}
    }
}
