using UnityEngine;
using System.Collections;
using Assets.Scripts.Game;

public class PlayerCC : MonoBehaviour {

    public Vector2 wouldBeSpeed = new Vector2();

	public float maxSpeed = 5.0f;
	public bool facingRight = true;
	public Transform target;
	public float jumpSpeed = 10.0f;
	public float gravity = 1.0f;
	public float radius = 2.0f;

	float t = 0.0f;
	float vpos = 0.0f;
	float vspeed = 0.0f;

	public Animator anim;

	float halfheight;
	bool hasGround;
	float groundVPos;
	int numCollision = 0;
	public Game game; // FIXME public

	public void wrapToLevel(float oldradius, float newradius) {
		radius = newradius;
		groundVPos = newradius;
		transform.position = new Vector2(transform.position.x * newradius / oldradius, newradius + halfheight);
	}

	// Use this for initialization
	void Start () {
//		anim = GetComponent<Animator>();
		BoxCollider2D cbox = GetComponent<BoxCollider2D>();
		halfheight = cbox.size.y / 2.0f;
		hasGround = false;
		groundVPos = 0.0f;
	}

	//void FindGround() {
	//}

	void FixedUpdate() {
		//FindGround();

		// Wrap player around
		float layerRadius = game.GetLayerRadius(game.Layer);
		Vector3 newpos = transform.position;
		if ( newpos.x > layerRadius * Mathf.PI ) {
			newpos.x -= layerRadius * 2.0f * Mathf.PI;
		}
		if ( newpos.x < -layerRadius * Mathf.PI ) {
			newpos.x += layerRadius * 2.0f * Mathf.PI;
		}
		transform.position = newpos;

		vpos = transform.position.y - halfheight;
		//vspeed = rigidbody2D.velocity.y;
		//Debug.Log(vpos);

		if ( vpos <= groundVPos + 0.05 ) {
		//if ( Mathf.Abs(rigidbody2D.velocity.y) <= 0.05f ) {
			vspeed = 0.0f;
			vpos   = groundVPos;
            anim.SetInteger("jump", 0);
			if (Input.GetKey(KeyCode.Space)) {
                vspeed = jumpSpeed;
                anim.SetInteger("jump", 1);
			}
		}
        if (vspeed < 0)
            anim.SetInteger("jump", 2);
		vspeed -= gravity;
		float move = Input.GetAxis("Horizontal");
		rigidbody2D.velocity = new Vector2(move * maxSpeed, vspeed);
        wouldBeSpeed = new Vector2(move * maxSpeed, vspeed);
		anim.SetFloat("speed", Mathf.Abs(move));
        if (wouldBeSpeed.x > 0)
            facingRight = true;
        else
            facingRight = false;
	}

	void OnCollisionEnter2D(Collision2D coll) {
		//Debug.Log("Collision: gr=" + groundVPos + " vpos=" + vpos);
		foreach (ContactPoint2D contact in coll.contacts) {
			//Debug.DrawRay(contact.point, contact.normal, Color.white);
			if ( contact.normal.y > 0.7 ) {
				if ( contact.point.y > groundVPos ) {
					groundVPos = contact.point.y;
				}
			}
		}
		//Debug.Log("Collision end: gr=" + groundVPos + " vpos=" + vpos);
		numCollision += coll.contacts.Length;
	}

	void OnCollisionExit2D(Collision2D coll) {
		//Debug.Log("Collision EXIT: gr=" + groundVPos + " vpos=" + vpos + " N=" + coll.contacts.Length);
		//Debug.Log("Collision EXIT end: gr=" + groundVPos + " vpos=" + vpos);
		numCollision -= coll.contacts.Length;
		if ( numCollision <= 0 ) {
			numCollision = 0;
			groundVPos = -1000.0f;
			hasGround = false;
            anim.SetInteger("jump", 2);
		}
	}
	
	// Update is called once per frame
	void Update () {

		// FIXME TODO WARNING CHEAT ############################
		if (Input.GetKeyDown(KeyCode.E)) {
			game.ChangeLayer(1, true);
		}
		else if (Input.GetKeyDown(KeyCode.Q))
		{
			game.ChangeLayer(-1, true);
		}
		// #####################################################

		var r = transform.position.y;
		var t = transform.position.x / radius - Mathf.PI / 2.0f;
		target.position = new Vector3(r * Mathf.Cos(t), -r * Mathf.Sin(t), 0.0f);
		target.rotation = Quaternion.AngleAxis(Mathf.Rad2Deg * (-t - Mathf.PI / 2.0f), Vector3.forward);
	
	}
}
