﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Collider2D))]
[RequireComponent(typeof(Rigidbody2D))]
public class Pushable : MonoBehaviour {

    enum Side { right, left, none}

    bool touchingPlayer = false;
    Side side = Side.none;

    GameObject player;
    PlayerCC pcc;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void FixedUpdate () {
        
        if (touchingPlayer && Input.GetKey(KeyCode.J))
        {
            Vector2 pushSpeed = new Vector2(pcc.wouldBeSpeed.x, 0.0f);
            if (side == Side.right && !pcc.facingRight && pushSpeed.x < 0)
                rigidbody2D.velocity = pushSpeed;
            else if (side == Side.left && pcc.facingRight && pushSpeed.x > 0)
                rigidbody2D.velocity = pushSpeed;
        }
        else
            rigidbody2D.velocity = new Vector2();
	}

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.gameObject.tag == "PlayerPushCollider")
        {
            var go = other.gameObject;
            pcc = go.transform.parent.gameObject.GetComponent("PlayerCC") as PlayerCC;
            if (pcc.facingRight)
            {
                side = Side.left;
                Debug.Log("Side.left");
            }
            else
            {
                side = Side.right;
                Debug.Log("Side.right");
            }
            touchingPlayer = true;
            player = other.gameObject;
        }
    }

    void OnTriggerExit2D(Collider2D other)
    {
        if (other.gameObject.tag == "PlayerPushCollider")
            touchingPlayer = false;
    }
}
