﻿using UnityEngine;
using System.Collections;

public class SpawnPhysics : MonoBehaviour {

	public bool unfold = false;

	private GameObject physobj = null;
	private float radius = 0.0f;

	// Use this for initialization
	void Start () {
		if ( unfold ) {
			unfoldPhysics();
		}
		else {
			movePhysics();
		}
	}

	void unfoldPhysics() {
		CircleCollider2D csph = GetComponent<CircleCollider2D>();
		radius = csph.radius;
		var length = Mathf.PI * 2.0f * radius;
		physobj = new GameObject(name + "_phys");
		var cbox = physobj.AddComponent("BoxCollider2D") as BoxCollider2D;
		cbox.center = new Vector2(0.0f, radius - 0.5f);
		cbox.size = new Vector2(3.0f * length, 1.0f);
		GameObject.Destroy(csph);
	}

	void movePhysics() {
		float layerRadius = 2.14f;
		var r = transform.position.magnitude;
		var t = Mathf.Atan2(transform.position.y, transform.position.x) - Mathf.PI / 2.0f;
		Debug.Log("Pos=" + transform.position + " r=" + r + " t=" + t);
		var position = new Vector3(-t * layerRadius, r, 0.0f);
		var rotation = Quaternion.AngleAxis(Mathf.Rad2Deg * t, Vector3.forward);
		//enabled = false;
		physobj = new GameObject(name + "_");
		//physobj = GameObject.Instantiate(gameObject, position, rotation) as GameObject;
		physobj.name = name + "_phys";
		//GameObject.Destroy(physobj.GetComponent("SpawnPhysics"));
		GameObject.Destroy(GetComponent<Collider2D>());
		// how to remove rendering form phys obj ?
	}
}
