﻿using UnityEngine;
using System.Collections;
using Assets.Scripts.Game;

public class WorldColorFilterBehaviour : MonoBehaviour {

    GameManager gm;
    Game game;

    public Sprite violet;
    public Sprite blue;
    public Sprite green;

	// Use this for initialization
	void Start () {
        gm = GameObject.FindGameObjectWithTag("GameManager").GetComponent("GameManager") as GameManager;
        if (gm == null) Debug.Log("Could not find game!! ");
        game = gm.Game;
        if (game == null)
            Debug.Log("Cant find game!");
        game.PropertyChanged += game_PropertyChanged;
	}

    void game_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
    {
        if (e.PropertyName == "Layer")
        {
            Debug.Log("We are switching layer: " + game.Layer);
            switch (game.Layer)
            {
                case 0:
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = violet;
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sortingOrder = -5;
                    break;
                case 1:
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = blue;
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sortingOrder = -15;
                    break;
                case 2:
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sprite = green;
                    (GetComponent("SpriteRenderer") as SpriteRenderer).sortingOrder = -25;
                    break;
            }
        }
    }
}
